<template>
  <div>
    <gz-report-selector ref="reportSelector"></gz-report-selector>
    <div v-if="formState.ready">
      <gz-error :error-box-message="formState.errorBoxMessage"></gz-error>
      <v-form ref="form">
        <v-tabs v-model="tab" mobile-breakpoint="100" @change="tabChanged">
          <v-tab>{{ $ay.t("HeadOffice") }}</v-tab>
          <v-tab>{{ $ay.t("Address") }}</v-tab>
          <v-tab>{{ $ay.t("Contacts") }}</v-tab>

          <v-tabs-items v-model="tab">
            <v-tab-item class="mt-4 ml-2">
              <v-row dense>
                <v-col cols="12" sm="6" lg="4" xl="3">
                  <v-text-field
                    ref="name"
                    v-model="obj.name"
                    dense
                    :readonly="formState.readOnly"
                    :label="$ay.t('HeadOfficeName')"
                    :rules="[form().required(this, 'name')]"
                    :error-messages="form().serverErrors(this, 'name')"
                    data-cy="name"
                    @input="fieldValueChanged('name')"
                  ></v-text-field>
                </v-col>

                <v-col
                  v-if="form().showMe(this, 'AccountNumber')"
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <v-text-field
                    ref="accountNumber"
                    v-model="obj.accountNumber"
                    dense
                    :readonly="formState.readOnly"
                    :label="$ay.t('HeadOfficeAccountNumber')"
                    data-cy="accountNumber"
                    :error-messages="form().serverErrors(this, 'accountNumber')"
                    @input="fieldValueChanged('accountNumber')"
                  ></v-text-field>
                </v-col>

                <v-col
                  v-if="form().showMe(this, 'WebAddress')"
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <gz-url
                    ref="webAddress"
                    v-model="obj.webAddress"
                    :readonly="formState.readOnly"
                    :label="$ay.t('WebAddress')"
                    data-cy="webAddress"
                    :error-messages="form().serverErrors(this, 'webAddress')"
                    @input="fieldValueChanged('webAddress')"
                  ></gz-url>
                </v-col>

                <v-col
                  v-if="form().showMe(this, 'EmailAddress')"
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <gz-email
                    ref="emailAddress"
                    v-model="obj.emailAddress"
                    :readonly="formState.readOnly"
                    :label="$ay.t('HeadOfficeEmail')"
                    data-cy="emailAddress"
                    :error-messages="form().serverErrors(this, 'emailAddress')"
                    @input="fieldValueChanged('emailAddress')"
                  ></gz-email>
                </v-col>

                <v-col
                  v-if="form().showMe(this, 'Phone1')"
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <gz-phone
                    ref="phone1"
                    v-model="obj.phone1"
                    :readonly="formState.readOnly"
                    :label="$ay.t('HeadOfficePhone1')"
                    data-cy="phone1"
                    :error-messages="form().serverErrors(this, 'phone1')"
                    @input="fieldValueChanged('phone1')"
                  ></gz-phone>
                </v-col>

                <v-col
                  v-if="form().showMe(this, 'Phone2')"
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <gz-phone
                    ref="phone2"
                    v-model="obj.phone2"
                    :readonly="formState.readOnly"
                    :label="$ay.t('HeadOfficePhone2')"
                    data-cy="phone2"
                    :error-messages="form().serverErrors(this, 'phone2')"
                    @input="fieldValueChanged('phone2')"
                  ></gz-phone>
                </v-col>

                <v-col
                  v-if="form().showMe(this, 'Phone3')"
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <gz-phone
                    ref="phone3"
                    v-model="obj.phone3"
                    :readonly="formState.readOnly"
                    :label="$ay.t('HeadOfficePhone3')"
                    data-cy="phone3"
                    :error-messages="form().serverErrors(this, 'phone3')"
                    @input="fieldValueChanged('phone3')"
                  ></gz-phone>
                </v-col>

                <v-col
                  v-if="form().showMe(this, 'Phone4')"
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <gz-phone
                    ref="phone4"
                    v-model="obj.phone4"
                    :readonly="formState.readOnly"
                    :label="$ay.t('HeadOfficePhone4')"
                    data-cy="phone4"
                    :error-messages="form().serverErrors(this, 'phone4')"
                    @input="fieldValueChanged('phone4')"
                  ></gz-phone>
                </v-col>

                <v-col
                  v-if="form().showMe(this, 'Phone5')"
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <gz-phone
                    ref="phone5"
                    v-model="obj.phone5"
                    :readonly="formState.readOnly"
                    :label="$ay.t('HeadOfficePhone5')"
                    data-cy="phone5"
                    :error-messages="form().serverErrors(this, 'phone5')"
                    @input="fieldValueChanged('phone5')"
                  ></gz-phone>
                </v-col>

                <v-col
                  v-if="form().showMe(this, 'ContractId')"
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <gz-pick-list
                    ref="contractId"
                    v-model="obj.contractId"
                    :aya-type="ayaTypes().Contract"
                    show-edit-icon
                    :readonly="formState.readOnly"
                    :label="$ay.t('Contract')"
                    data-cy="contractId"
                    :error-messages="form().serverErrors(this, 'contractId')"
                    @input="fieldValueChanged('contractId')"
                  ></gz-pick-list>
                </v-col>

                <v-col
                  v-if="
                    form().showMe(this, 'ContractExpires') && obj.contractId
                  "
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <gz-date-time-picker
                    ref="contractExpires"
                    v-model="obj.contractExpires"
                    :label="$ay.t('ContractExpires')"
                    :readonly="formState.readOnly"
                    data-cy="contractExpires"
                    :error-messages="
                      form().serverErrors(this, 'contractExpires')
                    "
                    @input="fieldValueChanged('contractExpires')"
                  ></gz-date-time-picker>
                </v-col>

                <!-- <v-col
                  v-if="form().showMe(this, 'UsesBanking')"
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <v-checkbox
                    v-model="obj.usesBanking"
                    :readonly="formState.readOnly"
                    :label="$ay.t('UsesBanking')"
                    ref="usesBanking"
                    data-cy="usesBanking"
                    :error-messages="form().serverErrors(this, 'usesBanking')"
                    @change="fieldValueChanged('usesBanking')"
                  >
                    <template v-slot:append v-if="canOpenServiceBank()">
                      <v-btn
                        outlined
                        small
                        color="primary"
                        @click="openServiceBank"
                        class="ml-12"
                      >
                        <v-icon>$ayiCarBattery</v-icon></v-btn
                      >
                    </template></v-checkbox
                  >
                </v-col> -->
                <v-col cols="12" sm="6" lg="4" xl="3">
                  <v-checkbox
                    ref="active"
                    v-model="obj.active"
                    dense
                    :readonly="formState.readOnly"
                    :label="$ay.t('Active')"
                    data-cy="active"
                    :error-messages="form().serverErrors(this, 'active')"
                    @change="fieldValueChanged('active')"
                  ></v-checkbox>
                </v-col>
                <!-- --------------------------------- -->
                <v-col v-if="form().showMe(this, 'Notes')" cols="12">
                  <v-textarea
                    ref="notes"
                    v-model="obj.notes"
                    dense
                    :readonly="formState.readOnly"
                    :label="$ay.t('HeadOfficeNotes')"
                    :error-messages="form().serverErrors(this, 'notes')"
                    data-cy="notes"
                    auto-grow
                    @input="fieldValueChanged('notes')"
                  ></v-textarea>
                </v-col>

                <v-col v-if="form().showMe(this, 'Tags')" cols="12">
                  <gz-tag-picker
                    ref="tags"
                    v-model="obj.tags"
                    :readonly="formState.readOnly"
                    data-cy="tags"
                    :error-messages="form().serverErrors(this, 'tags')"
                    @input="fieldValueChanged('tags')"
                  ></gz-tag-picker>
                </v-col>

                <v-col cols="12">
                  <gz-custom-fields
                    ref="customFields"
                    v-model="obj.customFields"
                    :form-key="formCustomTemplateKey"
                    :readonly="formState.readOnly"
                    :parent-v-m="this"
                    data-cy="customFields"
                    :error-messages="form().serverErrors(this, 'customFields')"
                    @input="fieldValueChanged('customFields')"
                  ></gz-custom-fields>
                </v-col>

                <v-col v-if="form().showMe(this, 'Wiki')" cols="12">
                  <gz-wiki
                    ref="wiki"
                    v-model="obj.wiki"
                    :aya-type="ayaType"
                    :aya-id="obj.id"
                    :readonly="formState.readOnly"
                    @input="fieldValueChanged('wiki')"
                  ></gz-wiki
                ></v-col>

                <v-col
                  v-if="form().showMe(this, 'Attachments') && obj.id"
                  cols="12"
                >
                  <gz-attachments
                    :readonly="formState.readOnly"
                    :aya-type="ayaType"
                    :aya-id="obj.id"
                  ></gz-attachments
                ></v-col>
              </v-row>
            </v-tab-item>
            <v-tab-item class="mt-4 ml-2">
              <v-row dense>
                <v-col cols="12">
                  <v-menu v-if="rights.change" offset-y>
                    <template v-slot:activator="{ on, attrs }">
                      <span class="text-h6">
                        {{ $ay.t("AddressTypePhysical") }}</span
                      ><v-btn icon v-bind="attrs" v-on="on">
                        <v-icon small>$ayiEllipsisV</v-icon>
                      </v-btn>
                    </template>
                    <v-list>
                      <v-list-item @click="AddressCopyPhysicalToClipBoard()">
                        <v-list-item-icon>
                          <v-icon>$ayiCopy</v-icon>
                        </v-list-item-icon>
                        <v-list-item-title>{{
                          $ay.t("CopyToClipboard")
                        }}</v-list-item-title>
                      </v-list-item>
                      <v-list-item @click="AddressCopyToPostal">
                        <v-list-item-icon>
                          <v-icon>$ayiClone</v-icon>
                        </v-list-item-icon>
                        <v-list-item-title>{{
                          $ay.t("AddressCopyToPostal")
                        }}</v-list-item-title>
                      </v-list-item>
                      <v-list-item @click="GeoCapture">
                        <v-list-item-icon>
                          <v-icon>$ayiMapMarker</v-icon>
                        </v-list-item-icon>
                        <v-list-item-title>{{
                          $ay.t("GeoCapture")
                        }}</v-list-item-title>
                      </v-list-item>
                    </v-list>
                  </v-menu>
                  <span v-else class="text-h6">
                    {{ $ay.t("AddressTypePhysical") }}</span
                  >
                </v-col>
                <v-col
                  v-if="form().showMe(this, 'Address')"
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <v-text-field
                    ref="address"
                    v-model="obj.address"
                    dense
                    :readonly="formState.readOnly"
                    :label="$ay.t('AddressDeliveryAddress')"
                    data-cy="address"
                    :error-messages="form().serverErrors(this, 'address')"
                    @input="fieldValueChanged('address')"
                  ></v-text-field>
                </v-col>

                <v-col
                  v-if="form().showMe(this, 'City')"
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <v-text-field
                    ref="city"
                    v-model="obj.city"
                    dense
                    :readonly="formState.readOnly"
                    :label="$ay.t('AddressCity')"
                    data-cy="city"
                    :error-messages="form().serverErrors(this, 'city')"
                    @input="fieldValueChanged('city')"
                  ></v-text-field>
                </v-col>

                <v-col
                  v-if="form().showMe(this, 'Region')"
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <v-text-field
                    ref="region"
                    v-model="obj.region"
                    dense
                    :readonly="formState.readOnly"
                    :label="$ay.t('AddressStateProv')"
                    data-cy="region"
                    :error-messages="form().serverErrors(this, 'region')"
                    @input="fieldValueChanged('region')"
                  ></v-text-field>
                </v-col>

                <v-col
                  v-if="form().showMe(this, 'Country')"
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <v-text-field
                    ref="country"
                    v-model="obj.country"
                    dense
                    :readonly="formState.readOnly"
                    :label="$ay.t('AddressCountry')"
                    data-cy="country"
                    :error-messages="form().serverErrors(this, 'country')"
                    @input="fieldValueChanged('country')"
                  ></v-text-field>
                </v-col>

                <v-col
                  v-if="form().showMe(this, 'AddressPostal')"
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <v-text-field
                    ref="addressPostal"
                    v-model="obj.addressPostal"
                    dense
                    :readonly="formState.readOnly"
                    :label="$ay.t('AddressPostal')"
                    data-cy="addressPostal"
                    :error-messages="form().serverErrors(this, 'addressPostal')"
                    @input="fieldValueChanged('addressPostal')"
                  ></v-text-field>
                </v-col>

                <v-col
                  v-if="form().showMe(this, 'Latitude')"
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <gz-decimal
                    ref="latitude"
                    v-model="obj.latitude"
                    :readonly="formState.readOnly"
                    :label="$ay.t('AddressLatitude')"
                    data-cy="latitude"
                    :rules="[form().decimalValid(this, 'latitude')]"
                    :error-messages="form().serverErrors(this, 'latitude')"
                    :precision="6"
                    @input="fieldValueChanged('latitude')"
                  ></gz-decimal>
                </v-col>

                <v-col
                  v-if="form().showMe(this, 'Longitude')"
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <gz-decimal
                    ref="longitude"
                    v-model="obj.longitude"
                    :readonly="formState.readOnly"
                    :label="$ay.t('AddressLongitude')"
                    data-cy="longitude"
                    :rules="[form().decimalValid(this, 'longitude')]"
                    :error-messages="form().serverErrors(this, 'longitude')"
                    :precision="6"
                    @input="fieldValueChanged('longitude')"
                  ></gz-decimal>
                </v-col>

                <v-col cols="12">
                  <v-menu v-if="rights.change" offset-y>
                    <template v-slot:activator="{ on, attrs }">
                      <span class="text-h6">
                        {{ $ay.t("AddressTypePostal") }}</span
                      ><v-btn icon v-bind="attrs" v-on="on">
                        <v-icon small>$ayiEllipsisV</v-icon>
                      </v-btn>
                    </template>
                    <v-list>
                      <v-list-item @click="AddressCopyPostalToClipBoard()">
                        <v-list-item-icon>
                          <v-icon>$ayiCopy</v-icon>
                        </v-list-item-icon>
                        <v-list-item-title>{{
                          $ay.t("CopyToClipboard")
                        }}</v-list-item-title>
                      </v-list-item>
                      <v-list-item @click="AddressCopyToPhysical">
                        <v-list-item-icon>
                          <v-icon>$ayiClone</v-icon>
                        </v-list-item-icon>
                        <v-list-item-title>{{
                          $ay.t("AddressCopyToPhysical")
                        }}</v-list-item-title>
                      </v-list-item>
                    </v-list>
                  </v-menu>
                  <span v-else class="text-h6">
                    {{ $ay.t("AddressTypePostal") }}</span
                  >
                </v-col>

                <v-col
                  v-if="form().showMe(this, 'PostAddress')"
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <v-text-field
                    ref="postAddress"
                    v-model="obj.postAddress"
                    dense
                    :readonly="formState.readOnly"
                    :label="$ay.t('AddressPostalDeliveryAddress')"
                    data-cy="postAddress"
                    :error-messages="form().serverErrors(this, 'postAddress')"
                    @input="fieldValueChanged('postAddress')"
                  ></v-text-field>
                </v-col>

                <v-col
                  v-if="form().showMe(this, 'PostCity')"
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <v-text-field
                    ref="postCity"
                    v-model="obj.postCity"
                    dense
                    :readonly="formState.readOnly"
                    :label="$ay.t('AddressPostalCity')"
                    data-cy="postCity"
                    :error-messages="form().serverErrors(this, 'postCity')"
                    @input="fieldValueChanged('postCity')"
                  ></v-text-field>
                </v-col>

                <v-col
                  v-if="form().showMe(this, 'PostRegion')"
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <v-text-field
                    ref="postRegion"
                    v-model="obj.postRegion"
                    dense
                    :readonly="formState.readOnly"
                    :label="$ay.t('AddressPostalStateProv')"
                    data-cy="postRegion"
                    :error-messages="form().serverErrors(this, 'postRegion')"
                    @input="fieldValueChanged('postRegion')"
                  ></v-text-field>
                </v-col>

                <v-col
                  v-if="form().showMe(this, 'PostCountry')"
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <v-text-field
                    ref="postCountry"
                    v-model="obj.postCountry"
                    dense
                    :readonly="formState.readOnly"
                    :label="$ay.t('AddressPostalCountry')"
                    data-cy="postCountry"
                    :error-messages="form().serverErrors(this, 'postCountry')"
                    @input="fieldValueChanged('postCountry')"
                  ></v-text-field>
                </v-col>

                <v-col
                  v-if="form().showMe(this, 'PostCode')"
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <v-text-field
                    ref="postCode"
                    v-model="obj.postCode"
                    dense
                    :readonly="formState.readOnly"
                    :label="$ay.t('AddressPostalPostal')"
                    data-cy="postCode"
                    :error-messages="form().serverErrors(this, 'postCode')"
                    @input="fieldValueChanged('postCode')"
                  ></v-text-field>
                </v-col>
              </v-row>
            </v-tab-item>
            <v-tab-item class="mt-4 ml-2">
              <v-row dense>
                <v-col cols="12">
                  <v-data-table
                    v-model="selected"
                    dense
                    :headers="headers"
                    :items="contactsObj"
                    class="elevation-1"
                    :disable-pagination="true"
                    :disable-filtering="true"
                    hide-default-footer
                    :sort-by="['name']"
                    :show-select="false"
                    :header-props="{ sortByText: $ay.t('Sort') }"
                    data-cy="custUsersTable"
                    :no-data-text="$ay.t('NoData')"
                    @click:row="contactsRowClick"
                  >
                    <template v-slot:[`item.active`]="{ item }">
                      <v-simple-checkbox
                        v-model="item.active"
                        disabled
                      ></v-simple-checkbox>
                    </template>

                    <template v-slot:top>
                      <div class="text-right mb-6">
                        <v-btn
                          :disabled="obj.id == 0"
                          @click="contactsGetDataFromApi"
                        >
                          <v-icon data-cy="refresh">$ayiSync</v-icon>
                        </v-btn>
                        <v-btn
                          class="ml-12"
                          :disabled="obj.id == 0 || formState.readOnly"
                          @click="addContact"
                        >
                          <v-icon data-cy="add">$ayiPlus</v-icon>
                        </v-btn>
                      </div>
                    </template>
                  </v-data-table>
                </v-col>
              </v-row>
            </v-tab-item>
          </v-tabs-items>
        </v-tabs>
      </v-form>
    </div>
    <v-overlay :value="!formState.ready || formState.loading">
      <v-progress-circular indeterminate :size="64" />
    </v-overlay>
  </div>
</template>
<script>
const FORM_KEY = "head-office-edit";
const API_BASE_URL = "head-office/";
const FORM_CUSTOM_TEMPLATE_KEY = "HeadOffice";
export default {
  data() {
    return {
      formCustomTemplateKey: FORM_CUSTOM_TEMPLATE_KEY,
      selectLists: {
        usertypes: []
      },
      obj: {
        id: 0,
        concurrency: 0,
        name: null,
        active: true,
        notes: null,
        wiki: null,
        customFields: "{}",
        tags: [],
        webAddress: null,
        accountNumber: null,
        // usesBanking: false,
        contractId: null,
        contractExpires: null,
        phone1: null,
        phone2: null,
        phone3: null,
        phone4: null,
        phone5: null,
        emailAddress: null,
        postAddress: null,
        postCity: null,
        postRegion: null,
        postCountry: null,
        postCode: null,
        address: null,
        city: null,
        region: null,
        country: null,
        addressPostal: null,
        latitude: null,
        longitude: null
      },
      tab: 0,
      formState: {
        ready: false,
        dirty: false,
        valid: true,
        readOnly: false,
        loading: true,
        errorBoxMessage: null,
        appError: null,
        serverError: {}
      },
      rights: window.$gz.role.defaultRightsObject(),
      ayaType: window.$gz.type.HeadOffice,
      contactsObj: [],
      hasFetchedContacts: false,
      headers: [],
      selected: [],
      availableRoles: [],
      timeZoneName: window.$gz.locale.getResolvedTimeZoneName(),
      languageName: window.$gz.locale.getResolvedLanguage(),
      hour12: window.$gz.locale.getHour12()
    };
  },
  watch: {
    formState: {
      handler: function(val) {
        if (this.formState.loading) {
          return;
        }
        if (val.dirty && val.valid && !val.readOnly) {
          window.$gz.eventBus.$emit("menu-enable-item", FORM_KEY + ":save");
        } else {
          window.$gz.eventBus.$emit("menu-disable-item", FORM_KEY + ":save");
        }
        if (!val.dirty && val.valid && !val.readOnly) {
          window.$gz.eventBus.$emit(
            "menu-enable-item",
            FORM_KEY + ":duplicate"
          );
          window.$gz.eventBus.$emit("menu-enable-item", FORM_KEY + ":new");
        } else {
          window.$gz.eventBus.$emit(
            "menu-disable-item",
            FORM_KEY + ":duplicate"
          );
          window.$gz.eventBus.$emit("menu-disable-item", FORM_KEY + ":new");
        }
      },
      deep: true
    }
  },
  async created() {
    const vm = this;
    try {
      await initForm(vm);
      vm.rights = window.$gz.role.getRights(window.$gz.type.HeadOffice);
      vm.formState.readOnly = !vm.rights.change;
      window.$gz.eventBus.$on("menu-click", clickHandler);
      let setDirty = false;
      //id 0 means create or duplicate to new
      if (vm.$route.params.recordid != 0) {
        //is there already an obj from a prior operation?
        if (this.$route.params.obj) {
          //yes, no need to fetch it
          this.obj = this.$route.params.obj;
        } else {
          await vm.getDataFromApi(vm.$route.params.recordid);
        }
      } else {
        //Might be a duplicate and contain another record
        if (this.$route.params.obj) {
          this.obj = this.$route.params.obj;
          this.obj.concurrency = undefined;
          this.obj.id = 0;
          this.obj.name = `${this.obj.name} - ${window.$gz.translation.get(
            "Copy"
          )}`;
          setDirty = true;
        }
      }
      window.$gz.form.setFormState({
        vm: vm,
        loading: false,
        dirty: setDirty,
        valid: true
      });
      generateMenu(vm);
    } catch (error) {
      window.$gz.errorHandler.handleFormError(error, vm);
    } finally {
      vm.formState.ready = true;
    }
  },
  async beforeRouteLeave(to, from, next) {
    if (!this.formState.dirty || JUST_DELETED) {
      next();
      return;
    }
    if ((await window.$gz.dialog.confirmLeaveUnsaved()) === true) {
      next();
    } else {
      next(false);
    }
  },
  beforeDestroy() {
    window.$gz.eventBus.$off("menu-click", clickHandler);
  },
  methods: {
    // canOpenServiceBank: function() {
    //   return this.obj.usesBanking == true && this.$route.params.recordid != 0;
    // },
    // openServiceBank: function() {
    //   if (this.canOpenServiceBank()) {
    //     this.$router.push({
    //       name: "service-banks",
    //       params: {
    //         aType: window.$gz.type.HeadOffice,
    //         objectId: this.$route.params.recordid,
    //         viz: this.obj.name,
    //         icon: "$ayiSitemap"
    //       }
    //     });
    //   }
    // },
    canSave: function() {
      return this.formState.valid && this.formState.dirty;
    },
    canDuplicate: function() {
      return this.formState.valid && !this.formState.dirty;
    },
    ayaTypes: function() {
      return window.$gz.type;
    },
    form() {
      return window.$gz.form;
    },
    fieldValueChanged(ref) {
      if (
        this.formState.ready &&
        !this.formState.loading &&
        !this.formState.readOnly
      ) {
        window.$gz.form.fieldValueChanged(this, ref);
      }
    },
    async getDataFromApi(recordId) {
      const vm = this;
      window.$gz.form.setFormState({
        vm: vm,
        loading: true
      });
      if (!recordId) {
        throw new Error(FORM_KEY + "::getDataFromApi -> Missing recordID!");
      }
      try {
        window.$gz.form.deleteAllErrorBoxErrors(vm);
        const res = await window.$gz.api.get(API_BASE_URL + recordId);
        if (res.error) {
          if (res.error.code == "2010") {
            window.$gz.form.handleObjectNotFound(vm);
          }
          vm.formState.serverError = res.error;
          window.$gz.form.setErrorBoxErrors(vm);
        } else {
          vm.obj = res.data;
          generateMenu(vm);
          window.$gz.form.setFormState({
            vm: vm,
            dirty: false,
            valid: true,
            loading: false
          });
        }
      } catch (error) {
        window.$gz.errorHandler.handleFormError(error, vm);
      } finally {
        window.$gz.form.setFormState({
          vm: vm,
          loading: false
        });
      }
    },
    async submit() {
      const vm = this;
      if (vm.canSave == false) {
        return;
      }

      try {
        window.$gz.form.setFormState({
          vm: vm,
          loading: true
        });
        window.$gz.form.deleteAllErrorBoxErrors(vm);
        const res = await window.$gz.api.upsert(API_BASE_URL, vm.obj);
        if (res.error) {
          vm.formState.serverError = res.error;
          window.$gz.form.setErrorBoxErrors(vm);
        } else {
          if (res.data.id) {
            //POST
            vm.obj = res.data;
            this.$router.replace({
              name: "head-office-edit",
              params: {
                recordid: res.data.id,
                obj: res.data
              }
            });
          } else {
            //PUT
            vm.obj.concurrency = res.data.concurrency;
          }
          window.$gz.form.setFormState({
            vm: vm,
            dirty: false,
            valid: true
          });
        }
      } catch (ex) {
        window.$gz.errorHandler.handleFormError(ex, vm);
      } finally {
        window.$gz.form.setFormState({
          vm: vm,
          loading: false
        });
      }
    },
    async remove() {
      try {
        const dialogResult = await window.$gz.dialog.confirmDelete();
        if (dialogResult != true) {
          return;
        }
        window.$gz.form.setFormState({
          vm: this,
          loading: true
        });
        if (this.$route.params.recordid == 0) {
          JUST_DELETED = true;
          this.$router.go(-1);
        } else {
          window.$gz.form.deleteAllErrorBoxErrors(this);
          const res = await window.$gz.api.remove(
            API_BASE_URL + this.$route.params.recordid
          );
          if (res.error) {
            this.formState.serverError = res.error;
            window.$gz.form.setErrorBoxErrors(this);
          } else {
            JUST_DELETED = true;
            this.$router.go(-1);
          }
        }
      } catch (error) {
        window.$gz.errorHandler.handleFormError(error, this);
      } finally {
        window.$gz.form.setFormState({
          vm: this,
          loading: false
        });
      }
    },
    duplicate() {
      this.$router.push({
        name: "head-office-edit",
        params: {
          recordid: 0,
          obj: this.obj
        }
      });
    },

    tabChanged: async function(tab) {
      if (tab == 2) {
        //contacts tab, load contacts if not done already
        if (!this.hasFetchedContacts) {
          await this.contactsGetDataFromApi();
        }
      }
    },
    addContact() {
      if (this.obj.id == 0) {
        return;
      }
      this.$router.push({
        name: "cust-user",
        params: { recordid: 0, headofficeid: this.obj.id }
      });
    },
    contactsRowClick(item) {
      window.$gz.eventBus.$emit("openobject", {
        type: window.$gz.type.User,
        id: item.id,
        inside: false
      });
    },
    rolesDisplayFromRoles(roles) {
      const roleNames = [];
      if (roles != null && roles != 0) {
        for (let i = 0; i < this.availableRoles.length; i++) {
          const role = this.availableRoles[i];
          if (roles & role.id) {
            roleNames.push(role.name);
          }
        }
      }
      return roleNames.join(", ");
    },
    async contactsGetDataFromApi() {
      const vm = this;
      vm.formState.loading = true;

      window.$gz.form.deleteAllErrorBoxErrors(vm);
      try {
        const res = await window.$gz.api.get(
          `user/head-office-contacts/${vm.obj.id}`
        );
        vm.hasFetchedContacts = true;
        if (res.error) {
          if (res.error.code == "2010") {
            window.$gz.form.handleObjectNotFound(vm);
          }
          vm.formState.serverError = res.error;
          window.$gz.form.setErrorBoxErrors(vm);
        } else {
          if (res.data) {
            const ret = [];
            for (let i = 0; i < res.data.length; i++) {
              const o = res.data[i];
              ret.push({
                id: o.id,
                name: o.name,
                emailAddress: o.emailAddress,
                phone1: o.phone1,
                phone2: o.phone2,
                phone3: o.phone3,
                active: o.active,
                lastLogin: window.$gz.locale.utcDateToShortDateAndTimeLocalized(
                  o.lastLogin,
                  this.timeZoneName,
                  this.languageName,
                  this.hour12
                )
              });
            }
            vm.contactsObj = ret;
          } else {
            vm.rawObj = [];
            vm.contactsObj = [];
          }
          window.$gz.form.setFormState({
            vm: vm,
            dirty: false,
            valid: true,
            loading: false
          });
          generateMenu(vm);
        }
      } catch (error) {
        window.$gz.form.setFormState({
          vm: vm,
          loading: false
        });
        window.$gz.errorHandler.handleFormError(error, vm);
      }
    },
    AddressCopyToPostal() {
      const vm = this;
      vm.obj.postAddress = vm.obj.address;
      vm.obj.postCity = vm.obj.city;
      vm.obj.postRegion = vm.obj.region;
      vm.obj.postCountry = vm.obj.country;
      this.formState.dirty = true;
    },
    AddressCopyToPhysical() {
      const vm = this;
      vm.obj.address = vm.obj.postAddress;
      vm.obj.city = vm.obj.postCity;
      vm.obj.region = vm.obj.postRegion;
      vm.obj.country = vm.obj.postCountry;
      this.formState.dirty = true;
    },
    AddressCopyPhysicalToClipBoard() {
      const vm = this;
      let ret = "";
      if (vm.obj.name) {
        ret += vm.obj.name + "\n";
      }
      if (vm.obj.address) {
        ret += vm.obj.address + "\n";
      }

      if (vm.obj.city) {
        ret += vm.obj.city + " ";
      }

      if (vm.obj.region) {
        ret += vm.obj.region + " ";
      }

      if (vm.obj.country) {
        ret += vm.obj.country + "\n";
      }

      if (vm.obj.addressPostal) {
        //Postal codes should have two spaces before them according to regs.
        ret += "  " + vm.obj.addressPostal + "\n";
      }
      window.$gz.util.copyToClipboard(ret);
      /* todo maybe down the road if asked for?

    if(mAddressType==AddressTypes.Physical)
    {
     if(mLatitude!=0 || mLongitude!=0)
     {
      sb.Append(" \r\n");
      sb.Append(LongitudeToString(mLongitude));
      sb.Append("   ");
      sb.Append(LatitudeToString(mLatitude));
      sb.Append(" \r\n");
     }
    } */
    },
    AddressCopyPostalToClipBoard() {
      const vm = this;
      let ret = "";
      if (vm.obj.name) {
        ret += vm.obj.name + "\n";
      }
      if (vm.obj.postAddress) {
        ret += vm.obj.postAddress + "\n";
      }

      if (vm.obj.postCity) {
        ret += vm.obj.postCity + " ";
      }

      if (vm.obj.postRegion) {
        ret += vm.obj.postRegion + " ";
      }

      if (vm.obj.postCode) {
        //Postal codes should have two spaces before them according to regs.
        ret += "  " + vm.obj.postCode + "\n";
      }

      if (vm.obj.postCountry) {
        ret += vm.obj.postCountry + "\n";
      }
      window.$gz.util.copyToClipboard(ret);
    },
    async GeoCapture() {
      const vm = this;
      try {
        window.$gz.form.deleteAllErrorBoxErrors(vm);
        const loc = await window.$gz.util.getGeoLocation();
        vm.obj.latitude = loc.latitude;
        vm.fieldValueChanged("latitude");
        vm.obj.longitude = loc.longitude;
        vm.fieldValueChanged("longitude");
      } catch (ex) {
        window.$gz.errorHandler.handleFormError(ex, vm);
      }
    }
  }
};

/////////////////////////////
//
//
async function clickHandler(menuItem) {
  if (!menuItem) {
    return;
  }
  const m = window.$gz.menu.parseMenuItem(menuItem);
  if (m.owner == FORM_KEY && !m.disabled) {
    switch (m.key) {
      case "save":
        m.vm.submit();
        break;
      case "delete":
        m.vm.remove();
        break;
      case "new":
        m.vm.$router.push({
          name: "head-office-edit",
          params: { recordid: 0 }
        });
        break;
      case "duplicate":
        m.vm.duplicate();
        break;
      case "report":
        {
          const res = await m.vm.$refs.reportSelector.open(
            {
              AType: window.$gz.type.HeadOffice,
              selectedRowIds: [m.vm.obj.id]
            },
            m.id
          );
          if (res == null) {
            return;
          }
          window.$gz.form.setLastReportMenuItem(FORM_KEY, res, m.vm);
        }
        break;
      case "geoview":
        window.$gz.util.viewGeoLocation({
          latitude: m.vm.obj.latitude,
          longitude: m.vm.obj.longitude,
          address: m.vm.obj.address || m.vm.obj.postAddress,
          city: m.vm.obj.city || m.vm.obj.postCity,
          region: m.vm.obj.region || m.vm.obj.postRegion,
          country: m.vm.obj.country || m.vm.obj.postCountry,
          postCode: m.vm.obj.postCode,
          addressPostal: m.vm.obj.addressPostal
        });
        break;
      case "CustomerList":
        m.vm.$router.push({
          name: "cust-customers",
          params: {
            aType: m.vm.ayaType,
            objectId: m.vm.obj.id,
            name: m.vm.obj.name
          }
        });
        break;
      default:
        window.$gz.eventBus.$emit(
          "notify-warning",
          FORM_KEY + "::context click: [" + m.key + "]"
        );
    }
  }
}

//////////////////////
//
//
function generateMenu(vm) {
  const menuOptions = {
    isMain: false,
    readOnly: vm.formState.readOnly,
    icon: "$ayiSitemap",
    title: "HeadOffice",
    helpUrl: "head-offices",
    formData: {
      ayaType: window.$gz.type.HeadOffice,
      recordId: vm.$route.params.recordid,
      formCustomTemplateKey: FORM_CUSTOM_TEMPLATE_KEY,
      recordName: vm.obj.name
    },
    menuItems: []
  };

  if (vm.rights.change) {
    menuOptions.menuItems.push({
      title: "Save",
      icon: "$ayiSave",
      surface: true,
      key: FORM_KEY + ":save",
      vm: vm
    });
  }

  menuOptions.menuItems.push({
    title: "Report",
    icon: "$ayiFileAlt",
    key: FORM_KEY + ":report",
    vm: vm
  });

  const lastReport = window.$gz.form.getLastReport(FORM_KEY);
  if (lastReport != null) {
    menuOptions.menuItems.push({
      title: lastReport.name,
      notrans: true,
      icon: "$ayiFileAlt",
      key: FORM_KEY + ":report:" + lastReport.id,
      vm: vm
    });
  }

  if (vm.rights.change) {
    menuOptions.menuItems.push({
      title: "New",
      icon: "$ayiPlus",
      key: FORM_KEY + ":new",
      vm: vm
    });
  }

  if (vm.rights.change && vm.$route.params.recordid != 0) {
    menuOptions.menuItems.push({
      title: "Duplicate",
      icon: "$ayiClone",
      key: FORM_KEY + ":duplicate",
      vm: vm
    });
  }
  if (vm.rights.delete && vm.$route.params.recordid != 0) {
    menuOptions.menuItems.push({
      title: "Delete",
      icon: "$ayiTrashAlt",
      surface: false,
      key: FORM_KEY + ":delete",
      vm: vm
    });
  }
  menuOptions.menuItems.push({ divider: true, inset: false });

  menuOptions.menuItems.push({
    title: "CustomerList",
    icon: "$ayiAddressCard",
    key: FORM_KEY + ":CustomerList",
    vm: vm
  });

  menuOptions.menuItems.push({
    title: "GeoView",
    icon: "$ayiMapMarked",
    key: FORM_KEY + ":geoview",
    vm: vm
  });

  menuOptions.menuItems.push({ divider: true, inset: false });
  window.$gz.eventBus.$emit("menu-change", menuOptions);
}

let JUST_DELETED = false;

/////////////////////////////////
//
//
async function initForm(vm) {
  await fetchTranslatedText();
  await window.$gz.formCustomTemplate.get(FORM_CUSTOM_TEMPLATE_KEY, vm);
  await createTableHeaders(vm);
}

//////////////////////////////////////////////////////////
//
// Ensures UI translated text is available
//
async function fetchTranslatedText() {
  await window.$gz.translation.cacheTranslations([
    "HeadOffice",
    "HeadOfficeName",
    "HeadOfficeNotes",
    "WebAddress",
    "HeadOfficeAccountNumber",
    "Contract",
    "ContractExpires",
    "HeadOfficePhone1",
    "HeadOfficePhone2",
    "HeadOfficePhone3",
    "HeadOfficePhone4",
    "HeadOfficePhone5",
    "HeadOfficeEmail",
    "AddressTypePhysical",
    "AddressTypePostal",
    "AddressCopyToPostal",
    "AddressCopyToPhysical",
    "Address",
    "AddressPostalDeliveryAddress",
    "AddressPostalCity",
    "AddressPostalStateProv",
    "AddressPostalCountry",
    "AddressPostalPostal",
    "AddressDeliveryAddress",
    "AddressCity",
    "AddressStateProv",
    "AddressCountry",
    "AddressPostal",
    "AddressLatitude",
    "AddressLongitude",
    "HeadOfficeCustom1",
    "HeadOfficeCustom2",
    "HeadOfficeCustom3",
    "HeadOfficeCustom4",
    "HeadOfficeCustom5",
    "HeadOfficeCustom6",
    "HeadOfficeCustom7",
    "HeadOfficeCustom8",
    "HeadOfficeCustom9",
    "HeadOfficeCustom10",
    "HeadOfficeCustom11",
    "HeadOfficeCustom12",
    "HeadOfficeCustom13",
    "HeadOfficeCustom14",
    "HeadOfficeCustom15",
    "HeadOfficeCustom16",
    "UserEmailAddress",
    "UserPhone1",
    "UserPhone2",
    "UserPageAddress",
    "Contact",
    "LastLogin",
    "CustomerList"
  ]);
}

//////////////////////
//
//
async function createTableHeaders(vm) {
  vm.headers = [
    { text: vm.$ay.t("Contact"), value: "name" },
    { text: vm.$ay.t("UserEmailAddress"), value: "emailAddress" },
    { text: vm.$ay.t("UserPhone1"), value: "phone1" },
    { text: vm.$ay.t("UserPhone2"), value: "phone2" },
    { text: vm.$ay.t("UserPageAddress"), value: "phone3" },
    { text: vm.$ay.t("Active"), value: "active" },
    { text: vm.$ay.t("LastLogin"), value: "lastLogin" }
  ];
}
</script>
